x.y.z
=====

Release date:

New features:

* Add a language menu
  - The active Language can be now set via a menu at the top-right corner
  - The selected language will saved and automatically loaded again
  - Setting language in the CLI will override the selected language

* Add basque translation (eu)

* Add Portuguese translation (pt_Pt, pt_Br)

* Make zoom-to-fit take possibly selected nodes into account

* Fix GitHub Issue #165: Keep node handles usable
  - Nodes are now raised and zoomed in on mouse hover
  - This behavior can be disabled by Settings => Editing => Raise node on mouse hover

Bug fixes:

* Fix default image size in PNG export dialog
  - Set the default image size to current view size
  - Set a more sensible upper limit for the image size

* Fix zooming when searching text on labels

* Fix position offset issues when creating a new node by dragging

* Fix GitHub Issue #259: 2 build errors in Windows

* Fix very slow node insertion on large mind maps

Other:

4.4.0
=====

Release date:

Wed, 27 Mar 2024 22:29:16 +0200

New features:

* Search text also in edge labels

* Implement group deletion of edges

* Apply text search on undo/redo

Bug fixes:

* Fix GitHub Issue #191: Windows: Text highlighted by the search not visible

* Fix GitHub Issue #255: Run error in ArchLinux

* Fix search field not always taking focus on startup

4.3.0
=====

Release date:

Tue, 12 Dec 2023 21:33:12 +0200

New features:

* Fix GitHub Issue #249: Option to include grid on export
    - Grid will be exported if set visible
    - Works for both PNG and SVG exports

* Fix GitHub Issue #251: Feature request: child has same colors as parent
  - Change "Copy on Drag" behavior so that only the style will be copied

* Set default filename with a timestamp in PNG and SVG export dialogs

* Disable recent file entries that don't exist anymore

Other:

* Optimize rendering of grid lines
  - Prevent situations where a zoomed-out view would have way too many grid
    lines visible, even multiple lines per pixel

4.2.0
=====

Release date:

Thu, 18 May 2023 15:51:49 -0000

New features:

* Automatic zoom-to-fit on search

* Enable clear button on search text edit

Other:

* Add small padding on the edge label text field

* Don't zoom to fit on cleared search if used has unselected all nodes

* Remove shadow effects from edges that are not completely visible while dragging

4.1.0
=====

Release date:

Fri, 17 Mar 2023 19:48:40 -0000

New features:

* Add setting for shadow effect optimization

* Layout optimization
  - Allow bigger aspect ratio
  - Allow longer edges

* Darker default outline for nodes

* Add subtle outline for edge labels

Bug fixes:

* Fix GitHub Issue #238: Shadow effects introduce performance issues

* Fix GitHub Issue #239: Cannot drag if the drag position is inside the virtual rectangle spanned by an edge

Other:

* Update Italian translations

* Update Dutch translations

* Performance
  - Don't update scene rect when adding edges
  - Remove shadow effects from edges as long edges can make dragging stutter

4.0.0
=====

Release date:

Fri, 10 Mar 2023 17:28:44 -0000

New features:

* Add setting for 'inverted controls'
  - Pan the view with a modifier key (Ctrl) and select a group of items without a modifier key being pressed

* Add parameter initialization options to layout optimization dialog

* Add progress indicator when opening a mind map

* Add tool tips for optimizer parameters

* Add tool tip text for selecting node group by intersection

* Change help texts into tool tips

Bug fixes:

* Fix tab key not working properly with node and edge text inputs

* Unselect implicitly selected node after context menu has closed

* Don't autosave unmodified mind map on exit

* Don't autosave unmodified mind map on new file or open file

Other:

* More subtle new version indicator with a timeout

* Change help texts to tool tips in edit settings

* Update Italian translations

* Update Dutch translations

* Breaking changes to ALZ-format (old files can still be opened normally)

  * Move style data into style element

  * Move layout optimizer config into metadata element

  * Save and load application and format versions separately

  * Rename index => i, index0 => i0, index1 => i1

3.7.0
=====

Release date:

Mon, 13 Feb 2023 19:21:18 -0000

New features:

* Add default settings for arrow size and edge width

* Add default settings for text size and font

* Add edit option to mirror the layout horizontally or vertically

* Animate edge deletion

* Animate node deletion

Bug fixes:

* Fix node left selected on canceled node/text color dialog

3.6.4
=====

Release date:

Mon, 19 Dec 2022 19:49:40 -0000

Bug fixes:

* Fix crash when trying to copy a group of connected nodes

Other:

* Update Italian translations

3.6.3
=====

Release date:

Sun, 11 Dec 2022 18:28:24 -0000

New features:

* Fix GitHub Issue #229: Add option to automatically open the last used file on application start
  - Autoload can be now enabled in edit settings

* Implement asynchronous file save for autosave
  - Fixes stuttering user experience on large files

Bug fixes:

* Fix Heimer Snap on Ubuntu 22.04
  - Didn't launch due to Wayland issues
  - Forced to X11 for now

Other:

* Initialize a new mind map to avoid an undefined state if the mind map fails to load

* Apply autosave only when settings dialog is accepted

* Increase edge with step to 0.25

* Update Dutch and Italian translations

3.6.2
=====

Release date:

Fri, 11 Nov 2022 16:22:10 -0000

New features:

* Add tooltips to node handles

* Set handle background color based on node color

* Light or dark text edit highlight based on node color

Bug fixes:

* Fix GitHub issue #224: Tests fail when compiled with UBSan

* Fix GitHub Issue #226: Attached node background images not loading    
  - Decode images in memory without exporting into a file first

Other:

* Add timestamp to log file name

* Save immediately when autosave enabled

3.6.1
=====

Release date:

Wed, 21 Sep 2022 18:26:35 -0000

Bug fixes:

* Fix shadow effect of edge label when edge is selected

* Fix edge label not deleted together with the edge

* Fix edge context menu not opening when edge text edit right-clicked

Other:

* constants.hpp: added <qreal> to QVector so that the compiler wouldn't throw an error

3.6.0
=====

Release date:

Sat, 27 Aug 2022 19:03:46 +0300

New features:

* Usability improvements:
  - Show a dummy edge label with '...' when the actual label won't fit
  - Stack edge text edits on top of nodes

3.5.0
=====

Release date:

Sat, 30 Jul 2022 21:12:12 +0300

New features:

* Fix GitHub Issue #112: Optimizer: Take current node locations into account when building initial layout
  - This change makes the optimizer way more stable with respect to the original global placement
  - Tries to find the best possible initial locations for the nodes in a normalized coordinate space
  - Makes only local changes within a very small search radius (row-wise and cell-wise)

Other:

* Update German translations

* Update Dutch translations

3.4.0
=====

Release date:

Sun, 26 Jun 2022 21:42:11 +0300

New features:

* Fetch the newest version and show in status bar if newer version available

* Fix GitHub Issue #210: Option to set shadow offset and disable shadows
  - Adds effects tab to the settings dialog
  - Shadow offset and blur radius can now be set

* Fix GitHub Issue #211: Color defaults
  - Default colors can now be set via the default settings tab

* Make it possible to tune shadow colors via the effects tab

3.3.0
=====

Release date:

Thu, 12 May 2022 21:09:29 +0300

New features:

* Add German translations

* Fix GitHub Issue #206: An option to change the size of the arrows
  - Toolbar now includes a spinner widget to set the arrow size

Bug fixes:

* Fix GitHub Issue #205: Click dragging from an existing node, 
  then pressing delete before dropping the node, crashes the program

3.2.0
=====

Release date:

Sat, 15 Jan 2022 20:42:13 +0200

New features:

* Fix GitHub Issue #181: Copy should copy also edges within the group
  - When copying (and pasting) nodes, also the edges within the copy group are now copied

Bug fixes:

* Fix GitHub Issue #195: Decrease size of "About" dialog

Other:

* Updated Dutch & Italian translations

3.1.0
=====

Release date:

Fri, 24 Dec 2021 12:47:41 +0200

New features:

* Option to automatically snap existing nodes to grid

* Option for dashed lines in the edge context menu

Bug fixes:

* Fix GitHub Issue #186: Icon is installed in /usr/share/icons/hicolor/64x64 but actual size is 256x256

* Fix GitHub Issue #188: Double-clicking on a large node zooms in incorrectly

* Fix GitHub Issue #189: Export to PNG breaks zoom out

* Fix GitHub Issue #190: Export to PNG works only once
  - Fixes the same issue with SVG export, too

Other:

* Simplify edge context menu

3.0.0
=====

Release date:

Sun, 21 Nov 2021 22:43:30 +0200

New features:

* Fix GitHub Issue #36: Double-click to zoom into a node
* Fix GitHub Issue #138: Make it possible to change the font
* Fix GitHub Issue #180: Make edge text disappear if it doesn't fit between nodes

Bug fixes:

* Fix auto save not triggering immediately on file operations

2.8.0
=====

Release date:

Mon, 25 Oct 2021 21:11:27 +0300

New features:

* Fix GitHub Issue #173: Being able to paste and create a node right-away
  - Pasting text to Heimer will create a new node with that text
  - Pasting image data e.g. from Gimp to Heimer will create a new node with that image

* Highlight text found by search
  - Not perfect as only the first occurrence is being matched

Bug fixes:

* Fix GitHub Issue #175: Windows installer doesn't add shortcuts

* Fix image save when original image is missing

* Write images with same id only once

Other:

* Unselect text on all nodes when background is clicked

2.7.0
=====

New features:

* Add Chinese translation

* Add Spanish translation

* Fix GitHub Issue #129: Add search field

Bug fixes:

* Fix editor scene getting broken when a file cannot be opened

Other:

* Limit application window startup size

2.6.0
=====

New features:

* Add support for .ALZ drag'n'drop

Other:

* Build Windows build with CMake

2.5.0
=====

New features:

* Middle-button support for selection rects

* Fix GitHub Issue #151: Default custom colors
  - Harmonizes color picker dialog between platforms

Other:

* Fix GitHub Issue #154: Do not deselect nodes on screen click
  - A modifier key (Shift, Ctrl) is now required to clear the selected group

2.4.0
=====

New features:

* Fix GitHub Issue #78: Add optional autosave
  - Autosave can be enabled in the settings menu

Bug fixes:

* Fix GitHub Issue #150: Ghost handles crash
* Fix GitHub Issue #148: Instant node creation not aligned with the grid

Other:

* Refactor dialogs to use more standard components
* Move settings menu action to file menu and remove settings menu

2.3.0
=====

New features:

* Fix GitHub Issue #140: Double-click to create a new node
* Add setting to select node group by intersection

Bug fixes:

* Fix GitHub Issue #143: Inexact node selection
  - Make connecting nodes by dragging easier
  - Render node handles as separate scene objects

Other:

* Fix GitHub Issue #125: Add support for Qt 6

2.2.0
=====

New features:

* Fix GitHub Issue #126: Extending limit of the canvas/background
  - The drawing area is now unlimited

* Fix GitHub Issue #128: Make it possible to connect selected nodes
  - Nodes can be connected in the selection order via Edit menu

* Fix GitHub Issue #133: Make it possible to disconnect selected nodes
  - Selected nodes can be disconnected via Edit menu

Bug fixes:

* Fix the way a node is selected on right-click

* Fix copy paste from background context menu

* Disable optimization buttons when optimization in progress

* Don't create Text element if edge text is empty

* Don't create Text element if node text is empty

Other:

* Make a distinction between general colors and node colors

* Make zooming nonlinear and increase range

* Make pasting of big group of nodes much faster

* Clear selected nodes when a handle of unselected node is clicked

2.1.0
=====

Other:

* Updated Dutch translations

2.0.0
=====

New features:

* Fix GitHub Issue #115: Missing Hotkey for Fullscreen: F11

* Fix GitHub Issue #119: Implement group actions
  - Make it possible to move group by move handle
  - Make it possible to set text color for a node group
  - Make it possible to set color for a node group
  - Make it possible to set attached image for a node group
  - Allow group action when setting colors via node handle
  - Allow deletion of multiple nodes

* Fix GitHub Issue #117: Make it possible to set default arrow direction

* Fix GitHub Issue #118: Make it possible to delete nodes with Delete key

* Fix GitHub Issue #121: Implement group copy and paste 

* Fix GitHub Issue #122: Make it possible to select node groups also with Shift key

Bug fixes:

* Fix GitHub Issue #120: Crash when connecting to the initial node

* Fix corner case issues with layout optimizer

Other:

* Prevent the system context menu on node text edit

* Open node context menu also when right-clicking on text edit

* Don't immediately hide handles on move because it's annoying

1.21.0
======

New features:

* Fix GitHub Issue #111: Optimizer: Save optimizer settings to file
* Fix GitHub Issue #109: Make default direction of arrows configurable

1.20.0
======

New features:

* Fix GitHub Issue #38: Add display grid option

Bug fixes:

* Fix Github Issue #106: Memory leak when changing Edge width, Text size and corner radius

Other:

* Fix GitHub Issue #98: Program doesn't remember the window being maximized

1.19.0
======

New features:

* Fix GitHub Issue #77: Ctrl+S on new map should directly open 'save as' dialog
* Fix GitHub Issue #85: Export SVG
* Fix GitHub Issue #100: Use a better initial directory when saving a new file
* Add Dutch translations

Bug fixes:

* Fix GitHub Issue #87: Group move doesn't work with the move handle
* Fix GitHub Issue #97: Redo does stuff when redo shouldn't be possible
* Fix GitHub Issue #96: Saving sometimes doesn't work after loading an existing file

Other:

* Fix GitHub Issue #99: Program doesn't remember grid size
* Fix GitHub Issue #101: Windows portable

1.18.0
======

New features:

* Add a shortcut Ctrl+Shift+F to create new floating nodes

Bug fixes:

* Make layout optimizer honor the active grid setting

Other:

* Usability improvement: Move create node action to top
* Usability improvement: Set optimize button as the default

1.17.0
======

New features:

* Fix GitHub Issue #50: Autoarrange Nodes
  - Implements a layout optimizer based on combinatorial optimization
  - Adds a new menu entry 'Edit => Optimize layout'

Bug fixes:

* Fix GitHub Issue #88: Crash when opening a new file in a certain scenario
* Fix GitHub Issue #89: Default Right-to-Left Text 

1.16.0
======

New features:

* Fix GitHub Issue #83: Add option to copy-drag nodes
  - By checking "Copy on drag" checkbox on the toolbar
    one can copy a node just by dragging a new connected node

* Add Ctrl+0 as shortcut for zoom to fit

Bug fixes:

* Fix GitHub Issue #70: Edge tries to reposition while moving a group

Other:

* Make the Full Screen menu action checkable to avoid confusion

* General code refactoring

* Upgraded to C++14

1.15.1
======

Other:

* Update Italian translations
* Use Argengine as the CLI argument parser

1.15.0
======

New features:

* Fix Github Issue #9: Show list of recent files
  
Bug fixes:

* Fix Github Issue #79: What's new view is editable 

1.14.0
======

New features:

* Add What's New dialog
  - Help => What's New
* Fix Github Issue #41: Allow nodes to be resized horizontally
  - Nodes will now automatically scale also horizontally by the text width

1.13.1
======

Bug fixes:

* Fix GitHub Issue #75: Unpredictable crash on delete node via context menu

1.13.0
======

Bug fixes:

* Fix GitHub Issue #72: UTF-8 saving not working (on Windows)
* Fix GitHub Issue #73: Extra newlines on Windows 

Other:

* Add --debug and turn some info logs into debug logs

1.12.0
======

New features:

* Fix GitHub Issue #67: Button to drag cards

* Fix GitHub Issue #66: Add fullscreen option
  * There's now View => Full Screen

* Fix GitHub Issue #51: Insert Images Into Nodes
  * Node context menu now includes "Attach image" and "Remove attached image"
  * The attached image will be set as the background image of the node
  * The image data is embedded in the .ALZ-file

Other:

* Fix GitHub Issue #68: Build .qm-files as part of the build process

1.11.0
======

New features:

* Fix GitHub Issue #59: Enable text entry in newly created nodes
* Fix GitHub Issue #61: System dialogs are not localized
* Fix GitHub Issue #55: Ability to copy the node without connection

1.10.0 - "Summer Serafina"
==========================

New features:

* Fix GitHub Issue #58: Add selection rectangle for nodes
  * With Ctrl pressed one can now draw a selection rectangle
* Add Italian translations

1.9.0 - "Arrow Amalgam"
=======================

New features:

* Fix GitHub Issue #53: Add option to set corner radius
* Fix GitHub Issue #32: Add mechanism to set arrow direction
  * Right-click on edge shows a context menu with options to set single arrow, double arrow, hide arrows, and reverse the direction
* Fix GitHub Issue #25: Add a way to delete edges
  * Right-click on edge opens context menu with a delete option

Bug fixes:

* Fix GitHub Issue #54: Moving a non-selected node moves selection group

Other:

* Snap: Fix desktop-qt5 not working as a remote part anymore
* Snap: Fix mouse cursor theme

1.8.0 - "Mighty Move"
=====================

New features:

* Fix GitHub Issue #26: Multi-selection for nodes
  * Ctrl + Left click selects/deselects nodes
  * Ctrl + Left click on background clears selection

Bug fixes:

* Tests
  * Fix edge-specific undo tests
  * Fix node-specific undo tests

Other:

* Tests
  * Add redo tests

1.7.0 - "Merry Misc"
====================

New features:

* French translations
* Fix GitHub Issue #18: Setting for edge colors

Bug fixes:

* Fix GitHub Issue #47: Cannot open context menu if design is empty
* Fix GitHub Issue #46: Zoom to fit is broken on certain aspect ratios

Other:

* Disable zoom to fit if no nodes
* Disable export if no nodes

1.6.0 - "Grid Grudge"
=====================

New features:

* Fix GitHub Issue #39: Add snap to grid option
  * By selecting grid size > 0 will automatically snap nodes to grid

Other:

* Update Finnish translations

1.5.0 - "Edge Enhancement"
==========================

New features:

* Allow deletion of any node
* Fix GitHub Issue #5: Way to connect existing node to another node
  * Nodes can be connected together by dragging the (+) handle

Bug fixes:

* Remove animation glitches when node deleted during dot animations
* Fix GitHub Issue #10: Zoom level changes on undo/redo
* Fix GitHub Issue #34: Program crashes unsaved
* Clear undo stack on new design

Other:

* Tighter fit when exporting
* Adjust fit on dense layouts
* Disable animations of dummy drag edge
* Fix grammar in log messages
* Increase default edge width to 2.0
* Fix MUI_BRANDINGTEXT
* Snap: Use core18

1.4.0 - "Text Teaser"
=====================

New features:

* Fix GitHub Issue #28: Setting for font size

Bug fixes:

* Fix GitHub Issue #31: White text when using dark theme
* Fix a warning about missing Q_INTERFACES

Other:

* Fix unittest output paths

1.3.0 - "Colored Cream"
=======================

New features:

* Add transparency to node handles
* Add more contrast to the 'add' handle
* Add timeouts to node handles
* Don't show handles while dragging
* Fix GitHub Issue #7: Setting for text color
* Make node handles a bit smaller
* Take width into account when drawing edges

Bug Fixes:

* Fix GitHub Issue #30: Node handles are missing anti-aliasing and appear ugly

Other:

* Disable debug logging also if QT_NO_DEBUG defined
* Switch to SimpleLogger
* Update examples

1.2.0 - "Polished Puppy"
========================

New features:

* Add background color setting also to edit menu
* Add separators to the file menu
* Fix GitHub Issue #23: Setting for edge thickness
* Update icon (not sure if better)

Bug Fixes:

* Fix GitHub Issue #29: Errors when exporting to PNG not handled
* Fix GitHub Issue #22: Floating nodes cannot be deleted
* Automatically add file extension if filename manually entered

Other:

* Code refactorings

1.1.1 - "Bugfix Night"
======================

Bug fixes:

* Fix GitHub Issue #19: Save on close doesn't work
* Fix launcher icon of the Snap package

1.1.0 - "PNG Man"
=================

New features:

* Fix GitHub Issue #3: Export to PNG
* Fix GitHub Issue #6: Way to create floating nodes

Bug fixes:

* Fix windows icon resource name
* Fix GitHub Issue #12: Undoing the background color doesn't update the background immediately

Other:

* CMake: add fallback for C++11 standard setting if CMake version < 3.1

1.0.0 - "Bare Bones"
====================

Basic features for mind map editing.

New features:

* Easy-to-use UI
* Zoom with mouse wheel
* Nice animations
* Save/load in XML-based .ALZ-files
* Full undo/redo
* Zoom in/out/fit
* Quickly add node text and edge labels
* Node color and background color settings

